//+------------------------------------------------------------------+
//|                                                        Hans123MV |
//|                                               2005, Milan Volf   |
//+------------------------------------------------------------------+

//---- input parameters
extern int       Start1=8;
extern int       Start2=12;
extern bool      FirstSession=true;
extern bool      SecondSession=true;
extern int       Length=4;
extern int       EOD=23;
extern int       Pips=5;
extern int       StopLoss=70;
extern int       BreakEven=40;
extern int       TrailingStopStep=0;
extern int       TakeProfit=120;
extern double    Lots=0.1;
extern int       risk=10;                             // risk to calculate the lots size (only if mm is enabled)
extern double    DecreaseFactor=5;
extern string    TicketComment ="Hans123MV-2 sessions";
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   //---- 
   int i,Ticket,LastOrderTime,StartTime,StartTime1,StartTime2,EODTime,MN;
  
   
   //Settings
//   if (!IsTesting()){
//      if (Symbol()=="EURUSD"){
//         
//         StopLoss=50;
//         BreakEven=25;
//         TakeProfit=70;
//      }   
//      else if (Symbol()=="GBPUSD"){
//        
//         StopLoss=70;
//         BreakEven=40;
//         TakeProfit=120;
//      }
//      else {
//         
//      }
//   }

   //Count time
   if(CurTime()>=StrToTime(Start1+":00")-60){
      StartTime1=StrToTime(Start1+":00");
      StartTime2=StrToTime(Start2+":00");
      if(DayOfWeek()==5)   EODTime=MathMin(StrToTime("19:55"),StrToTime(EOD+":00"));
      else if (EOD==24)    EODTime=StrToTime("23:59");
      else                 EODTime=StrToTime(EOD+":00")-600;
   }
   
   //Set orders
   if(CurTime()>=StartTime1 && CurTime()<StartTime1+300 && FirstSession){
      MN=1;
      StartTime=StartTime1;
      SetOrders(MN,StartTime);
   }
   if(CurTime()>=StartTime2 && CurTime()<StartTime2+300 && SecondSession){
      MN=2;
      StartTime=StartTime2;
      SetOrders(MN,StartTime);
   }
   
   //Manage of open orders
   for (i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(CurTime()<=GlobalVariableGet("LastOrderTime")+10) Sleep(10000);
      if(CurTime()>=EODTime && (OrderMagicNumber()==1 || OrderMagicNumber()==2))
      {     //close open positions at EOD
         if(OrderSymbol()==Symbol() && OrderType()==OP_BUY)      OrderClose(OrderTicket(),OrderLots(),Bid,3,Red);
         if(OrderSymbol()==Symbol() && OrderType()==OP_SELL)     OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);
         if(OrderSymbol()==Symbol() && OrderType()==OP_BUYSTOP)  OrderDelete(OrderTicket());
         if(OrderSymbol()==Symbol() && OrderType()==OP_SELLSTOP) OrderDelete(OrderTicket());
         GlobalVariableSet("LastOrderTime",CurTime());
      }   
      else if( OrderMagicNumber()==1 || OrderMagicNumber()==2 ) {
         if(TrailingStopStep==0){    //move at BE if profit>BE
            if(OrderSymbol()==Symbol() && OrderType()==OP_BUY){
               if(High[0]-OrderOpenPrice()>=BreakEven*Point && OrderStopLoss()!=OrderOpenPrice()){
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Green);
                  GlobalVariableSet("LastOrderTime",CurTime());
               }   
            }   
            if(OrderSymbol()==Symbol() && OrderType()==OP_SELL){
               if(OrderOpenPrice()-Low[0]>=BreakEven*Point && OrderStopLoss()!=OrderOpenPrice()){
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Green);
                  GlobalVariableSet("LastOrderTime",CurTime());
               }
            }
         }
         else
         {                  //use trailing stop
         
         
       
          if(OrderType()==OP_BUY){
               if(High[0]-OrderStopLoss()>TrailingStopStep*Point){
                     OrderModify(OrderTicket(),OrderOpenPrice(),High[0]-TrailingStopStep*Point,OrderTakeProfit(),0,Green);
                     Sleep(10000);
                  }   
               }   
               if(OrderType()==OP_SELL){
                  if(OrderStopLoss()-Low[0]>TrailingStopStep*Point){
                     OrderModify(OrderTicket(),OrderOpenPrice(),Low[0]+TrailingStopStep*Point,OrderTakeProfit(),0,Green);
                     Sleep(10000);
                  }
               }
    
         
         } 
     
     
     
     
      }
   }// end for
   
   //Reset global variables at EOD
   if(CurTime()>=EODTime) GlobalVariablesDeleteAll();
   
   return(0);
  }
//+------------------------------------------------------------------+

int SetOrders(int MN,int StartTime){
   int i,Ticket,LastOrderTime,Bought=0,Sold=0,ShiftToStart,ShiftToBeginOfRange;
   double EntryLong,EntryShort,SLLong,SLShort,TPLong,TPShort;
   
   //Determine range
   ShiftToStart=iBarShift(NULL,0,StartTime)+1;
   ShiftToBeginOfRange=iBarShift(NULL,0,StartTime-Length*3600);
   EntryLong   =High[Highest(NULL,0,MODE_HIGH,ShiftToBeginOfRange,ShiftToStart)]+(Pips/*+MarketInfo(Symbol(),MODE_SPREAD)*/)*Point;
   EntryShort  =Low [Lowest (NULL,0,MODE_LOW, ShiftToBeginOfRange,ShiftToStart)]-Pips*Point;
   SLLong      =MathMax(EntryLong-StopLoss*Point,EntryShort);
   SLShort     =MathMin(EntryShort+StopLoss*Point,EntryLong);
   TPLong      =EntryLong+TakeProfit*Point;
   TPShort     =EntryShort-TakeProfit*Point;
   
   //Check Orders
   for (i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && (OrderType()==OP_BUYSTOP || OrderType()==OP_BUY) && OrderMagicNumber()==MN) Bought++;
      if(Bought>1){ //more than 1 buy order
         if(CurTime()<=GlobalVariableGet("LastOrderTime")+10) Sleep(10000);
         if(OrderSymbol()==Symbol() && OrderType()==OP_BUY)      OrderClose(OrderTicket(),OrderLots(),Bid,3,Red);
         if(OrderSymbol()==Symbol() && OrderType()==OP_BUYSTOP)  OrderDelete(OrderTicket());
      }
      if(OrderSymbol()==Symbol() && (OrderType()==OP_SELLSTOP || OrderType()==OP_SELL) && OrderMagicNumber()==MN) Sold++;
      if(Sold>1){ //more than 1 sell order
         if(CurTime()<=GlobalVariableGet("LastOrderTime")+10) Sleep(10000);
         if(OrderSymbol()==Symbol() && OrderType()==OP_SELL)     OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);
         if(OrderSymbol()==Symbol() && OrderType()==OP_SELLSTOP) OrderDelete(OrderTicket());
      }
   }
   if(Bought==0){ //no buy order
      if(CurTime()<=GlobalVariableGet("LastOrderTime")+10) Sleep(10000);
      Ticket=OrderSend(Symbol(),OP_BUYSTOP,GetLots((EntryLong-SLLong)/Point),EntryLong,3,SLLong,TPLong,TicketComment,MN,0,Green);
      if(Ticket<0 && GetLastError()==130)
         Ticket=OrderSend(Symbol(),OP_BUY,GetLots((Ask-SLLong)/Point),Ask,3,SLLong,TPLong,TicketComment,MN,0,Green);
      GlobalVariableSet("LastOrderTime",OrderOpenTime()); 
   }
   if(Sold==0){ //no sell order
      if(CurTime()<=GlobalVariableGet("LastOrderTime")+10) Sleep(10000);
      Ticket=OrderSend(Symbol(),OP_SELLSTOP,GetLots((SLShort-EntryShort)/Point),EntryShort,3,SLShort,TPShort,TicketComment,MN,0,Green);
      if(Ticket<0 && GetLastError()==130)
         Ticket=OrderSend(Symbol(),OP_SELL,GetLots((SLShort-Bid)/Point),Bid,3,SLShort,TPShort,TicketComment,MN,0,Green);
      GlobalVariableSet("LastOrderTime",OrderOpenTime()); 
   }
}

double GetLots(double _sl)
  {
   
   double lot=Lots;
   double MinLots=MarketInfo(Symbol(),MODE_MINLOT);
   double MaxLots=MarketInfo(Symbol(),MODE_MAXLOT);
   double TickVal=MarketInfo(Symbol(),MODE_TICKVALUE);
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
   int digLots=0;
   if(MinLots<0.1)digLots=2;
   else
      if(MinLots<1)digLots=1;
//--- select lot size
   if(_sl<=0 )_sl=iATR(Symbol(),PERIOD_D1,8,1)/Point;
   if(risk>0) lot=NormalizeDouble(AccountFreeMargin()*risk/100/TickVal/_sl,digLots);
//--- calcuulate number of losses orders without a break
   if(DecreaseFactor!=0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false)
           {
            Print("Error in history!");
            break;
           }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL)
            continue;
         //---
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1)
         lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,digLots);
     }
//--- return lot size
   return(MathMin(MaxLots,MathMax(MinLots,lot)));
  }
//+------------------------------------------------------------------+
